SET TERM ^ ;
CREATE PROCEDURE GET_TEKLA_SIMPLE (
    I_SKLAD_ID DOM_KEY,
    I_SIMPLE_ID DOM_KEY )
RETURNS (
    R_S_ID DOM_KEY,
    R_ME_ID DOM_KEY_SMALL,
    R_S_NAME DOM_CHAR_100,
    R_S_CODE DOM_CHAR_15,
    R_NAL DOM_KOL,
    R_RAZ_TIP_ID DOM_KEY,
    R_RAZFASOVKA_ID DOM_KEY,
    R_DDS DOM_CENA )
AS
BEGIN
    IF(:I_SIMPLE_ID<=0) 
    THEN begin
    
        for
        SELECT 
            S.ID, 
            COALESCE(S.ME_ID,0), 
            COALESCE(S.NAME,''), 
            COALESCE(S.CODE, ''),
            COALESCE(N.KOL_NAL, 0.0), 
            COALESCE(S.RAZ_TIP_ID,0), 
            COALESCE(DRS.RAZFASOVKA_ID,0),
            COALESCE(S.DDS,20.0)
        FROM 
            SIMPLE S LEFT join NAL N on (S.ID=N.SIMPLE_ID AND N.SKLAD_ID=:I_SKLAD_ID) 
            LEFT JOIN DEF_RAZ_SIMPLE DRS ON (S.ID=DRS.SIMPLE_ID) 
        WHERE 
            S.RSN in (0,2) AND S."ACTIVE"!='0'
        INTO
            :R_S_ID,:R_ME_ID,:R_S_NAME,:R_S_CODE,:R_NAL,:R_RAZ_TIP_ID,:R_RAZFASOVKA_ID,:R_DDS
        DO 
            SUSPEND;
        end
    else
    BEGIN
    IF (NOT EXISTS (SELECT * FROM SIMPLE WHERE ID=:I_SIMPLE_ID)) THEN EXIT;
        SELECT 
            S.ID, 
            COALESCE(S.ME_ID,0), 
            COALESCE(S.NAME,''), 
            COALESCE(S.CODE, ''),
            COALESCE(N.KOL_NAL, 0.0), 
            COALESCE(S.RAZ_TIP_ID,0), 
            COALESCE(DRS.RAZFASOVKA_ID,0),
            COALESCE(S.DDS,20.0)
        FROM 
            SIMPLE S LEFT join NAL N on (S.ID=N.SIMPLE_ID AND N.SKLAD_ID=:I_SKLAD_ID) 
            LEFT JOIN DEF_RAZ_SIMPLE DRS ON (S.ID=DRS.SIMPLE_ID) 
        WHERE 
            S.RSN in (0,2) AND S."ACTIVE"!='0' AND S.ID=:I_SIMPLE_ID
        INTO
            :R_S_ID,:R_ME_ID,:R_S_NAME,:R_S_CODE,:R_NAL,:R_RAZ_TIP_ID,:R_RAZFASOVKA_ID,:R_DDS;
        SUSPEND;
    END
        
END^
SET TERM ; ^

GRANT EXECUTE
 ON PROCEDURE GET_TEKLA_SIMPLE TO  SYSDBA;


 
 CREATE VIEW V_TEKLA_SYNC (SID, TIP, ITS, SKLAD_ID)
AS  
SELECT MAX(ID) AS SID,TIS.SYNCTIP AS TIP, TIS.ID_TO_SYNC AS ITS, TIS.SKLAD AS SKLAD_ID FROM TEKLA_INFO_SYNC TIS WHERE ( TIS.CNN_ID!=CURRENT_CONNECTION OR TIS.SYNCTIP=3) group by 2,3,4 order by 2 ASC,3 ASC;


SET TERM ^ ;
ALTER TRIGGER SIMPLE_AIU100 ACTIVE
AFTER INSERT OR UPDATE POSITION 100
AS 
BEGIN 
    
	if(NEW."ACTIVE"=0) THEN 
    begin
        INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(12,NEW.ID);
        EXIT;
    END
    
	if((not (NEW.ME_ID IS NULL)) AND ((INSERTING) OR (UPDATING AND (COALESCE(OLD.NAME,'')!=NEW.NAME OR COALESCE(OLD.ME_ID,0)!=NEW.ME_ID OR COALESCE(OLD.CODE,'')=NEW.CODE OR OLD."ACTIVE"!=NEW."ACTIVE")))) THEN  INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(2,NEW.ID);
   
END^
SET TERM ; ^