SET TERM ^ ;
ALTER TRIGGER SIMPLE_AIU100 ACTIVE
AFTER INSERT OR UPDATE POSITION 100
AS 
BEGIN 
    
	if(NEW."ACTIVE"=0) THEN 
    begin
        INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(12,NEW.ID);
        EXIT;
    END
    
	if((not (NEW.ME_ID IS NULL)) AND ((INSERTING) OR (UPDATING AND (COALESCE(OLD.NAME,'')!=NEW.NAME OR COALESCE(OLD.ME_ID,0)!=NEW.ME_ID OR COALESCE(OLD.CODE,'')!=NEW.CODE OR OLD."ACTIVE"!=NEW."ACTIVE")))) THEN  INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(2,NEW.ID);
   
END^
SET TERM ; ^


CREATE VIEW V_TEKLA_RAZ_TIP
AS
select RT.ID AS ID ,RT.NAME AS NAME,count(r.ID) AS COUNT_SUB from raz_tip rt left join RAZFASOVKA r on rt.ID=r.RAZ_TIP_ID group by 1,2 having count(r.id)>0;


SET TERM ^ ;
ALTER PROCEDURE GET_TEKLA_SIMPLE (
    I_SKLAD_ID DOM_KEY,
    I_SIMPLE_ID DOM_KEY )
RETURNS (
    R_S_ID DOM_KEY,
    R_ME_ID DOM_KEY_SMALL,
    R_S_NAME DOM_CHAR_100,
    R_S_CODE DOM_CHAR_15,
    R_NAL DOM_KOL,
    R_RAZ_TIP_ID DOM_KEY,
    R_RAZFASOVKA_ID DOM_KEY,
    R_DDS DOM_CENA,
    R_IS_USL CHAR(1))
AS
BEGIN
    IF(:I_SIMPLE_ID<=0) 
    THEN begin
    
        for
        SELECT 
            S.ID, 
            COALESCE(S.ME_ID,0), 
            COALESCE(S.NAME,''), 
            COALESCE(S.CODE, ''),
            COALESCE(N.KOL_NAL, 0.0), 
            COALESCE(S.RAZ_TIP_ID,0), 
            COALESCE(DRS.RAZFASOVKA_ID,-1),
            COALESCE(S.DDS,20.0),
            COALESCE(S.USLUGA,'0')
        FROM 
            SIMPLE S LEFT join NAL N on (S.ID=N.SIMPLE_ID AND N.SKLAD_ID=:I_SKLAD_ID) 
            LEFT JOIN DEF_RAZ_SIMPLE DRS ON (S.ID=DRS.SIMPLE_ID) 
        WHERE 
            S.RSN in (0,2) AND S."ACTIVE"!='0'
        INTO
            :R_S_ID,:R_ME_ID,:R_S_NAME,:R_S_CODE,:R_NAL,:R_RAZ_TIP_ID,:R_RAZFASOVKA_ID,:R_DDS,:R_IS_USL
        DO 
            SUSPEND;
        end
    else
    BEGIN
    IF (NOT EXISTS (SELECT * FROM SIMPLE WHERE ID=:I_SIMPLE_ID)) THEN EXIT;
        SELECT 
            S.ID, 
            COALESCE(S.ME_ID,0), 
            COALESCE(S.NAME,''), 
            COALESCE(S.CODE, ''),
            COALESCE(N.KOL_NAL, 0.0), 
            COALESCE(S.RAZ_TIP_ID,0), 
            COALESCE(DRS.RAZFASOVKA_ID,-1),
            COALESCE(S.DDS,20.0),
            COALESCE(S.USLUGA,'0')
        FROM 
            SIMPLE S LEFT join NAL N on (S.ID=N.SIMPLE_ID AND N.SKLAD_ID=:I_SKLAD_ID) 
            LEFT JOIN DEF_RAZ_SIMPLE DRS ON (S.ID=DRS.SIMPLE_ID) 
        WHERE 
            S.RSN in (0,2) AND S."ACTIVE"!='0' AND S.ID=:I_SIMPLE_ID
        INTO
            :R_S_ID,:R_ME_ID,:R_S_NAME,:R_S_CODE,:R_NAL,:R_RAZ_TIP_ID,:R_RAZFASOVKA_ID,:R_DDS,:R_IS_USL;
        SUSPEND;
    END
        
END^
SET TERM ; ^