update or INSERT INTO TEKLA_INFO (ID, NAME, LAST_SYNC)  VALUES (0,'< >',null) matching (id);
CREATE GENERATOR GEN_TEKLA_OPR_NODE_ID;

ALTER TABLE TEKLA_INFO ADD 
CNN_ID DOM_KEY;

ALTER TABLE TEKLA_INFO ADD 
OPR_ID DOM_KEY;

alter table TEKLA_INFO
add constraint FK_TEKLA_INFO_OPR_ID
foreign key (OPR_ID) 
references OPR (ID);


SET TERM ^ ;
ALTER TRIGGER NAL_AIU100 ACTIVE
AFTER INSERT OR UPDATE POSITION 100
AS 
BEGIN 
    IF((UPDATING AND not(OLD.KOL_NAL=NEW.KOL_NAL)) OR INSERTING) THEN INSERT INTO TEKLA_INFO_SYNC(SKLAD,SYNCTIP,ID_TO_SYNC) VALUES (NEW.SKLAD_ID,3,NEW.SIMPLE_ID);
END^
SET TERM ; ^

SET TERM ^ ;
ALTER TRIGGER SIMPLE_AIU100 ACTIVE
AFTER INSERT OR UPDATE POSITION 100
AS 
BEGIN 
    
	if((not (NEW.ME_ID IS NULL)) AND NEW."ACTIVE">0 AND ((INSERTING) OR (UPDATING AND NOT(OLD.NAME=NEW.NAME AND OLD.ME_ID=NEW.ME_ID AND OLD.CODE=NEW.CODE)))) THEN  INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(2,NEW.ID);
	if(NEW."ACTIVE"=0) THEN  INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(12,NEW.ID);
   
END^
SET TERM ; ^

SET TERM ^ ;
ALTER TRIGGER CENOVA_LISTA_EL_AIU100 ACTIVE
AFTER INSERT OR UPDATE POSITION 100
AS 
BEGIN 

	IF((INSERTING) OR (UPDATING AND NOT(OLD.CENA=NEW.CENA))) THEN INSERT INTO TEKLA_INFO_SYNC(SYNCTIP,ID_TO_SYNC) VALUES(5,NEW.ID);

END^
SET TERM ; ^

SET GENERATOR GEN_TEKLA_OPR_NODE_ID TO 0;

CREATE TABLE TEKLA_OPR_NODE
(
    ID DOM_KEY NOT NULL,
    TEKLA_ID DOM_KEY NOT NULL,
    OPR_ID DOM_KEY NOT NULL,
    
    CONSTRAINT PK_TEKLA_OPR_NODE PRIMARY KEY (ID),
    CONSTRAINT FK_TEKLA_OPR_NODE_TEKLA_ID FOREIGN KEY (TEKLA_ID) REFERENCES TEKLA_INFO(ID),
    CONSTRAINT FK_TEKLA_OPR_NODE_OPR_ID FOREIGN KEY (OPR_ID) REFERENCES OPR(ID)
);

SET TERM ^ ;

CREATE TRIGGER TEKLA_OPR_NODE_BI0 FOR TEKLA_OPR_NODE
BEFORE INSERT POSITION 0
AS 
BEGIN 
	IF(NEW.ID IS NULL) THEN NEW.ID = NEXT VALUE FOR GEN_TEKLA_OPR_NODE_ID;
    IF(NEW.TEKLA_ID IS NULL) THEN 
    begin
        IF(EXISTS(SELECT * FROM TEKLA_INFO WHERE CNN_ID=current_connection)) THEN SELECT ID FROM TEKLA_INFO WHERE CNN_ID=current_connection INTO NEW.TEKLA_ID;
        else NEW.TEKLA_ID=0;
    end
END^
SET TERM ; ^


SET TERM ^ ;

CREATE TRIGGER TEKLA_INFO_BU1 FOR TEKLA_INFO
ACTIVE BEFORE UPDATE POSITION 1
AS 
BEGIN 
    NEW.CNN_ID = IIF(NEW.ID=0,null,current_connection);
	IF(NOT(OLD.LAST_SYNC=NEW.LAST_SYNC)) THEN SELECT MAX(ID) FROM OPR INTO NEW.OPR_ID;
END^

SET TERM ; ^ 


SET TERM ^ ;
ALTER PROCEDURE TEKLA_COMMIT_ALL_SMETKI
RETURNS (
    R_INT_SMETKA_ID Bigint,
    R_OPR_ID Integer )
AS
DECLARE VARIABLE S_ID BIGINT; 
DECLARE VARIABLE S_KLI_ID INT;
DECLARE VARIABLE S_OBJ_ID SMALLINT;
DECLARE VARIABLE S_USER_ID SMALLINT;
DECLARE VARIABLE S_DATETIME TIMESTAMP;
DECLARE VARIABLE S_SUMA DOUBLE precision;
DECLARE VARIABLE S_SKLAD_ID SMALLINT;
DECLARE VARIABLE S_IP INT;
DECLARE VARIABLE S_IS_F SMALLINT;
DECLARE VARIABLE S_PAY_TIP SMALLINT;
DECLARE VARIABLE S_EL_SIMPLE_ID INT;
DECLARE VARIABLE S_EL_KOL DOUBLE precision;
DECLARE VARIABLE S_EL_PRICE_PL DOUBLE precision;
DECLARE VARIABLE S_EL_PRICE_OS DOUBLE precision;
DECLARE VARIABLE S_EL_PRICE DOUBLE PRECISION;
DECLARE VARIABLE S_EL_SUMA DOUBLE precision;

DECLARE VARIABLE P_OPR_ID INT;
DECLARE VARIABLE P_ID INT;
DECLARE VARIABLE P_OPR_PAY_NODE_ID INT;
DECLARE VARIABLE SUMI_OPR INT;
DECLARE VARIABLE SUMI_PAY INT;

DECLARE VARIABLE OU_ID INT;
DECLARE VARIABLE OU_EL_ID INT;
DECLARE VARIABLE SUMA_SR DOUBLE precision;
DECLARE VARIABLE SUMA_FR DOUBLE PRECISION;

BEGIN
FOR SELECT 
    TSI.ID,
    TSI.KLI_ID,
    TSI.USER_ID,
    TSI.SKLAD_ID,
    TSI.SUMA,
    TSI.DATETIME,
    TSI.IS_F,
    TSI.IP,
    TSI.PAY_TIP
FROM TEKLA_SMETKI_INFO TSI
INTO :S_ID,:S_KLI_ID,:S_USER_ID,:S_SKLAD_ID,:S_SUMA,:S_DATETIME,:S_IS_F,:S_IP,:S_PAY_TIP
DO 
begin

    SELECT OBEKT_ID FROM "USER" WHERE ID=:S_USER_ID INTO :S_OBJ_ID;
    EXECUTE PROCEDURE ADD_OPR(2,CAST(:S_DATETIME AS DATE),:S_IP,:S_USER_ID,:S_SKLAD_ID,NULLIF(:S_KLI_ID,0),:S_SUMA) RETURNING_VALUES :R_OPR_ID;
    UPDATE OR INSERT INTO TEKLA_OPR_NODE(OPR_ID) VALUES (:R_OPR_ID) MATCHING (OPR_ID);
    for SELECT
        TSIE.SIMPLE_ID,
        TSIE.KOL,
        TSIE.SUMA,
        TSIE.PRICE_PL,
        TSIE.PRICE,
		TSIE.PRICE_OS
    FROM TEKLA_SMETKI_I_EL TSIE
    WHERE TSIE.SMETKA_ID=:S_ID 
    INTO :S_EL_SIMPLE_ID,:S_EL_KOL,:S_EL_SUMA,:S_EL_PRICE_PL,:S_EL_PRICE,:S_EL_PRICE_OS
    DO
        begin
        EXECUTE PROCEDURE GET_SUMA_SR(:S_EL_SIMPLE_ID,:S_SKLAD_ID,:S_EL_KOL) RETURNING_VALUES :SUMA_SR;
        EXECUTE PROCEDURE ADD_OUT_EL(:R_OPR_ID,:S_EL_SIMPLE_ID,:S_EL_KOL,:S_EL_SUMA,COALESCE(SUMA_SR,0),0,'0',null) RETURNING_VALUES :OU_EL_ID;
        INSERT INTO PROD_CENI_EL(OUT_EL_ID,CENA,CENA_CL,CENA_OS) VALUES(:OU_EL_ID,:S_EL_PRICE,:S_EL_PRICE_PL,:S_EL_PRICE_OS);
        EXECUTE PROCEDURE PARTIDA_OUT(:S_EL_KOL,:S_EL_SIMPLE_ID,:S_SKLAD_ID,:R_OPR_ID,:OU_EL_ID,0,null,null,1) RETURNING_VALUES :S_EL_KOL,:S_EL_SUMA;--polzvame tezi, ve4e ne ni trqvat
        update opr set DATETIME = :S_DATETIME WHERE ID = :R_OPR_ID;
       
    END
    SELECT SUM (SUMA_SR), SUM (SUMA_FR) FROM OUT_EL WHERE OPR_ID = :R_OPR_ID INTO :SUMA_SR,:SUMA_FR;
    EXECUTE PROCEDURE ADD_OUT(:R_OPR_ID,IIF(:S_PAY_TIP=1,0,3),0,SUMA_SR,SUMA_FR,:S_IS_F,null,:S_OBJ_ID,0,null) RETURNING_VALUES :OU_ID;

    EXECUTE PROCEDURE UPDATE_OUT(:R_OPR_ID);
    INSERT INTO OPR_SUMI(OPR_ID,SUMA_FR,SUMA_SR) VALUES(:R_OPR_ID,:SUMA_FR,:SUMA_SR);
    R_INT_SMETKA_ID = :S_ID;
    IF(not (:S_PAY_TIP=1))
    THEN begin
    EXECUTE PROCEDURE ADD_OPR(6,CAST(:S_DATETIME AS DATE),:S_IP,:S_USER_ID,null,nullif(:S_KLI_ID,0),:S_SUMA) RETURNING_VALUES :P_OPR_ID;
     UPDATE OR INSERT INTO TEKLA_OPR_NODE(OPR_ID) VALUES (:P_OPR_ID) MATCHING (OPR_ID);
   INSERT INTO PAYMENT(OPR_ID) VALUES (:P_OPR_ID) RETURNING ID INTO :P_ID;
    --SELECT ID FROM PAYMENT WHERE OPR_ID = :P_OPR_ID INTO :P_ID;
    INSERT INTO PAYMENTS_EL(SUMA,PAYMENT_TIP_ID,PAYMENT_ID,KLI_ID) VALUES (:S_SUMA,:S_PAY_TIP,:P_ID,NULLIF(:S_KLI_ID,0));
    INSERT INTO SUMI(OPR_ID,SUMA,SUMA_OST) VALUES(:R_OPR_ID,:S_SUMA,0) RETURNING ID INTO :SUMI_OPR;
    --SELECT ID FROM SUMI WHERE OPR_ID=:R_OPR_ID INTO :SUMI_OPR;
    INSERT INTO SUMI(OPR_ID,SUMA,SUMA_OST) VALUES(:P_OPR_ID,:S_SUMA,0) RETURNING ID INTO :SUMI_PAY;
    --SELECT ID FROM SUMI WHERE OPR_ID=:R_OPR_ID INTO :SUMI_PAY;


    INSERT INTO OPR_PAYMENT_NODE (OPR_ID,PAYMENT_ID,SUMA) VALUES (:SUMI_OPR,:SUMI_PAY,:S_SUMA) RETURNING ID INTO :P_OPR_PAY_NODE_ID;
    --SELECT ID FROM OPR_PAYMENT_NODE WHERE OPR_ID=:SUMI_OPR AND PAYMENT_ID =:SUMI_PAY INTO ;
    
    INSERT INTO PAYMENT_NODE(OPR_ID,NODE_ID) VALUES (:SUMI_OPR,:P_OPR_PAY_NODE_ID);
    INSERT INTO PAYMENT_NODE(OPR_ID,NODE_ID) VALUES (:SUMI_PAY,:P_OPR_PAY_NODE_ID);

    END
    DELETE FROM TEKLA_SMETKI_INFO WHERE ID = :S_ID;
    suspend;
end
END^
SET TERM ; ^


GRANT EXECUTE
 ON PROCEDURE TEKLA_COMMIT_ALL_SMETKI TO  SYSDBA;



commit;
