SET TERM ^ ;
ALTER TRIGGER TEKLA_OPR_NODE_BI0 ACTIVE
BEFORE INSERT POSITION 0
AS 
BEGIN 
	IF(NEW.ID IS NULL) THEN NEW.ID = NEXT VALUE FOR GEN_TEKLA_OPR_NODE_ID;
END^
SET TERM ; ^

delete from tekla_opr_node;

ALTER TABLE TEKLA_OPR_NODE ADD 
SMETKA_ID BigInt NOT NULL;

ALTER TABLE TEKLA_SMETKI_INFO ADD 
TEKLA_ID DOM_KEY DEFAULT 0;


SET TERM ^ ;
ALTER PROCEDURE TEKLA_COMMIT_ALL_SMETKI
RETURNS (
    R_INT_SMETKA_ID Bigint,
    R_OPR_ID Integer )
AS

DECLARE VARIABLE S_KLI_ID INT; --,  
DECLARE VARIABLE S_OBJ_ID SMALLINT;--,  
DECLARE VARIABLE S_USER_ID SMALLINT;-- 
DECLARE VARIABLE S_DATETIME TIMESTAMP;--  
DECLARE VARIABLE S_SUMA DOUBLE precision;--   
DECLARE VARIABLE S_SKLAD_ID SMALLINT;--
DECLARE VARIABLE S_IP INT;--IP
DECLARE VARIABLE S_IS_F SMALLINT;--    
DECLARE VARIABLE S_PAY_TIP SMALLINT;--  (     "")
DECLARE VARIABLE S_T_ID INT;--TeklaID -            
DECLARE VARIABLE S_EL_SIMPLE_ID INT;--  
DECLARE VARIABLE S_EL_KOL DOUBLE precision;--
DECLARE VARIABLE S_EL_PRICE_PL DOUBLE precision;--    
DECLARE VARIABLE S_EL_PRICE_OS DOUBLE precision;--    
DECLARE VARIABLE S_EL_PRICE DOUBLE PRECISION;--,     
DECLARE VARIABLE S_EL_SUMA DOUBLE precision;--


DECLARE VARIABLE P_OPR_ID INT;--  
DECLARE VARIABLE P_ID INT;--  ,  
DECLARE VARIABLE P_OPR_PAY_NODE_ID INT;--  
DECLARE VARIABLE SUMI_OPR INT;--  ""
DECLARE VARIABLE SUMI_PAY INT;--  

DECLARE VARIABLE OU_ID INT;--  "out"
DECLARE VARIABLE OU_EL_ID INT;--  "out_el"
DECLARE VARIABLE SUMA_SR DOUBLE precision;
DECLARE VARIABLE SUMA_FR DOUBLE PRECISION;

BEGIN
FOR SELECT 
	TSI.ID,
	TON.OPR_ID
FROM TEKLA_SMETKI_INFO TSI JOIN TEKLA_OPR_NODE TON ON (TSI.ID=TON.SMETKA_ID AND TSI.TEKLA_ID=TON.TEKLA_ID)
INTO :R_INT_SMETKA_ID,:R_OPR_ID
DO 
begin
	DELETE FROM TEKLA_INFO_SYNC WHERE ID=:R_INT_SMETKA_ID;
	SUSPEND;
end
FOR SELECT 
    TSI.ID,
    TSI.KLI_ID,
    TSI.USER_ID,
    TSI.SKLAD_ID,
    TSI.SUMA,
    TSI.DATETIME,
    TSI.IS_F,
    TSI.IP,
    TSI.PAY_TIP,
    TSI.TEKLA_ID
FROM TEKLA_SMETKI_INFO TSI
INTO :R_INT_SMETKA_ID,:S_KLI_ID,:S_USER_ID,:S_SKLAD_ID,:S_SUMA,:S_DATETIME,:S_IS_F,:S_IP,:S_PAY_TIP,:S_T_ID
DO 
begin
    SELECT OBEKT_ID FROM "USER" WHERE ID=:S_USER_ID INTO :S_OBJ_ID;
    EXECUTE PROCEDURE ADD_OPR(2,CAST(:S_DATETIME AS DATE),:S_IP,:S_USER_ID,:S_SKLAD_ID,NULLIF(:S_KLI_ID,0),:S_SUMA) RETURNING_VALUES :R_OPR_ID;
    IF(:S_T_ID>0) THEN INSERT INTO TEKLA_OPR_NODE(OPR_ID,TEKLA_ID,SMETKA_ID) VALUES (:R_OPR_ID,:S_T_ID,:R_INT_SMETKA_ID);
    for SELECT
        TSIE.SIMPLE_ID,
        TSIE.KOL,
        TSIE.SUMA,
        TSIE.PRICE_PL,
        TSIE.PRICE,
		TSIE.PRICE_OS
    FROM TEKLA_SMETKI_I_EL TSIE
    WHERE TSIE.SMETKA_ID=:R_INT_SMETKA_ID 
    INTO :S_EL_SIMPLE_ID,:S_EL_KOL,:S_EL_SUMA,:S_EL_PRICE_PL,:S_EL_PRICE,:S_EL_PRICE_OS
    DO
        begin
        EXECUTE PROCEDURE GET_SUMA_SR(:S_EL_SIMPLE_ID,:S_SKLAD_ID,:S_EL_KOL) RETURNING_VALUES :SUMA_SR;
        EXECUTE PROCEDURE ADD_OUT_EL(:R_OPR_ID,:S_EL_SIMPLE_ID,:S_EL_KOL,:S_EL_SUMA,COALESCE(SUMA_SR,0),0,'0',null) RETURNING_VALUES :OU_EL_ID;
        INSERT INTO PROD_CENI_EL(OUT_EL_ID,CENA,CENA_CL,CENA_OS) VALUES(:OU_EL_ID,:S_EL_PRICE,:S_EL_PRICE_PL,:S_EL_PRICE_OS);
        EXECUTE PROCEDURE PARTIDA_OUT(:S_EL_KOL,:S_EL_SIMPLE_ID,:S_SKLAD_ID,:R_OPR_ID,:OU_EL_ID,0,null,null,1) RETURNING_VALUES :S_EL_KOL,:S_EL_SUMA;--polzvame tezi, ve4e ne ni trqvat
        update opr set DATETIME = :S_DATETIME WHERE ID = :R_OPR_ID;
       
    END
    SELECT SUM (SUMA_SR), SUM (SUMA_FR) FROM OUT_EL WHERE OPR_ID = :R_OPR_ID INTO :SUMA_SR,:SUMA_FR;
    EXECUTE PROCEDURE ADD_OUT(:R_OPR_ID,IIF(:S_PAY_TIP=1,0,3),0,SUMA_SR,SUMA_FR,:S_IS_F,null,:S_OBJ_ID,0,null) RETURNING_VALUES :OU_ID;

    EXECUTE PROCEDURE UPDATE_OUT(:R_OPR_ID);
    INSERT INTO OPR_SUMI(OPR_ID,SUMA_FR,SUMA_SR) VALUES(:R_OPR_ID,:SUMA_FR,:SUMA_SR);
    R_INT_SMETKA_ID = :R_INT_SMETKA_ID;
    IF(not (:S_PAY_TIP=1))
    THEN begin
    EXECUTE PROCEDURE ADD_OPR(6,CAST(:S_DATETIME AS DATE),:S_IP,:S_USER_ID,null,nullif(:S_KLI_ID,0),:S_SUMA) RETURNING_VALUES :P_OPR_ID;
    IF(:S_T_ID>0) THEN INSERT INTO TEKLA_OPR_NODE(OPR_ID,TEKLA_ID,SMETKA_ID) VALUES (:P_OPR_ID,:S_T_ID,:R_INT_SMETKA_ID);
	INSERT INTO PAYMENT(OPR_ID) VALUES (:P_OPR_ID) RETURNING ID INTO :P_ID;
    INSERT INTO PAYMENTS_EL(SUMA,PAYMENT_TIP_ID,PAYMENT_ID,KLI_ID) VALUES (:S_SUMA,:S_PAY_TIP,:P_ID,NULLIF(:S_KLI_ID,0));
    INSERT INTO SUMI(OPR_ID,SUMA,SUMA_OST) VALUES(:R_OPR_ID,:S_SUMA,0) RETURNING ID INTO :SUMI_OPR;
    INSERT INTO SUMI(OPR_ID,SUMA,SUMA_OST) VALUES(:P_OPR_ID,:S_SUMA,0) RETURNING ID INTO :SUMI_PAY;
    
    INSERT INTO OPR_PAYMENT_NODE (OPR_ID,PAYMENT_ID,SUMA) VALUES (:SUMI_OPR,:SUMI_PAY,:S_SUMA) RETURNING ID INTO :P_OPR_PAY_NODE_ID;
    
    INSERT INTO PAYMENT_NODE(OPR_ID,NODE_ID) VALUES (:SUMI_OPR,:P_OPR_PAY_NODE_ID);
    INSERT INTO PAYMENT_NODE(OPR_ID,NODE_ID) VALUES (:SUMI_PAY,:P_OPR_PAY_NODE_ID);

    END
    DELETE FROM TEKLA_SMETKI_INFO WHERE ID = :R_INT_SMETKA_ID;
    suspend;
end
END^
SET TERM ; ^

SET TERM ^ ;
ALTER TRIGGER TEKLA_INFO_BU1 ACTIVE
BEFORE UPDATE POSITION 1
AS 
BEGIN 
    NEW.CNN_ID = IIF(NEW.ID=0,null,current_connection);
END^
SET TERM ; ^
commit;
ALTER TABLE TEKLA_INFO DROP CONSTRAINT FK_TEKLA_INFO_OPR_ID;
ALTER TABLE TEKLA_INFO DROP OPR_ID;

commit;

